private import std.string;
private import std.stream;
private import std.stdio;

public:

char[] tostr(char[] v) { return v; }
invariant(char[]) tostr(char* v) { return std.string.toString(v); }
invariant(char[]) tostr(int v) {
	if (v < 0) {
		return "-" ~ std.string.toString(-v);
	}
	else {
		return std.string.toString(v);
	}
}
invariant(char[]) tostr(uint v) { return std.string.toString(v); }
invariant(char[]) tostr(bit v) { return std.string.toString(v); }
invariant(char[]) tostr(float v) {
	char[] ret;
	ret.length = 16;
	ret.length = sprintf(ret.ptr, "%f", v);
	return cast(invariant(char[]))ret;
}
invariant(char[]) tostr(double v) {
	char[] ret;
	ret.length = 16;
	ret.length = sprintf(ret.ptr, "%f", v);
	return cast(invariant(char[]))ret;
}
invariant(char[]) tostr(Object v) { return v.toString(); }

version (Test) {
	int main() {
		init();

		assert("1" == tostr(1));
		assert("-1" == tostr(-1));
		assert("0.100000" == tostr(0.1f));
		assert("0.200000" == tostr(0.2));
		assert("0" == tostr(false));
		assert("1" == tostr(true));

		uint hoge = 2;
		assert("2" == tostr(hoge));

		return 0;
	}
}
